// $Id: config_file.h,v 1.6 2002/12/14 11:19:11 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//
// TODO:
// what happens if value is present at addParameter?
//

#ifndef __config_file_h__
#define __config_file_h__

#include <map>
#include <string>
#include <iostream>

#include <string.h>

//#include "config_parser.h"
//#include "config_reader.h"

using std::map;
using std::cout;
using std::endl;
using std::string;
using std::pair;

//--------------------------------------------------------------------
class Section
{
 protected:
  typedef map<string, string> elements_t;
  elements_t parameters_;

 public:

  Section();
  virtual ~Section();
  const char* getStringParameter(const char* parameter) const;
  int getIntParameter(const char* parameter) const;
  void addParameter(const char*, const char*);
};

//--------------------------------------------------------------------
class ConfigFile
{
 protected:
  typedef map<string, Section>::const_iterator CI;
  typedef map<string, Section> sections_t;
  sections_t sections_;
  char* current_section_;
  
 public:
  ConfigFile();
  virtual ~ConfigFile();
  
  void addSection(const char* section);
  const char* getStringParameter(const char* section, const char* parameter) const;
  int getIntParameter(const char* section, const char* parameter) const;
  void addParameter(const char* section, const char* parameter, const char* value);
/*   void delParameter(const char* section, const char* parameter); */

  void dumpSections() const;

  //  friend ConfigParser::yyparse();
  //  friend ConfigReader::yylex();
  friend class ConfigParser;
};
#endif //__config_file_h__
