// $Id: device.h,v 1.9 2003/03/11 17:09:37 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __device_h__
#define __device_h__

#include <iostream>
#include <string>

#ifndef NULL
#define NULL 0
#endif

using std::string;

//----------------------------------------------------------------------
class Device
{
 protected:
  bool is_recordable_;
  bool is_supported_;
  bool is_stereo_;
  bool is_enabled_;
  bool is_muted_;
  bool record_source_;

  unsigned left_value_;
  unsigned right_value_;

  unsigned left_muted_;
  unsigned right_muted_;

  string name_;
  
 public:
  Device(bool, bool, bool, bool, const string&);
  virtual ~Device();

  virtual bool isMuted() const { return is_muted_;}
  virtual bool isStereo() const { return is_stereo_;}
  virtual bool isSupported() const { return is_supported_;}
  virtual bool isEnabled() const { return is_enabled_;}
  virtual bool isRecordable() const { return is_recordable_;}
  virtual bool getCapture() const { return record_source_;}

  virtual void mute();
  virtual void unMute();

  virtual unsigned getLeftValue() const;
  virtual unsigned getRightValue() const;

  virtual void setLeftValue(unsigned);
  virtual void setRightValue(unsigned);

  virtual const string& getLabel() const;
  virtual void enable();
  virtual void disable();

};


#endif //__device_h__
